rm(list=ls())
# ------- SET WORKING DIRECTORY ------- #
if (! "rstudioapi" %in% installed.packages() ) install.packages("rstudioapi")
wd <- dirname(rstudioapi::getSourceEditorContext()$path)
setwd(wd)


# load package to read excel data
require(readxl)

# read excel data
text.data <- read_xlsx("Monthly_Topic_Attention_Theta.xlsx", sheet = "Monthly_Topic_Attention_Theta")
# sort data
date <- as.Date(text.data[,1]$date)
data <- as.matrix(text.data[,-1])
groups.idx <- read_xlsx("Monthly_Topic_Attention_Theta.xlsx", sheet = "groups")
topic <- groups.idx$TOPIC
group <- groups.idx$GROUP
select.groups <- unique(group)

data.ind <- data
data.agg <- matrix(NA, nrow=length(date), ncol=length(select.groups))
for (i in 1:length(select.groups)){
  i.select.groups <- select.groups[i]
  data.agg[ ,i] <- rowSums(data[,group%in%i.select.groups])
}
colnames(data.agg) <- select.groups
txt.data.ind <- data.ind
txt.data.agg <- data.agg
txt.date <- date
save(txt.data.ind,txt.data.agg,txt.date,file='AggregateTextualData.RData')