#========================================
# links RavenPack to the rest of the data
#========================================
rm(list=ls())
# ------- SET WORKING DIRECTORY ------- #
if (! "rstudioapi" %in% installed.packages() ) install.packages("rstudioapi")
wd <- dirname(rstudioapi::getSourceEditorContext()$path)
setwd(wd)

if (! "stringr" %in% installed.packages() ) install.packages("stringr")
library(stringr)
if (! "compare" %in% installed.packages() ) install.packages("compare")
library(compare)
source("help_functions.R")

sort_all = FALSE
if (sort_all==TRUE){
  df <- read.csv("rp_company_mapping.csv",header = TRUE, sep =  ";")
  
  # GET COUNTRY - US - rp dataset
  rp_id_us <- df[df$DATA_VALUE%in%"US",]$RP_ENTITY_ID
  df_us <- df[df$RP_ENTITY_ID%in%rp_id_us,]
  
  # GET ALL FIRMS dataset from Compustat from 2000-01 to 2019-12 
  
  df_comp <- read.csv("CRSP_Tools_Translate_PERMCOPERMNO.csv",header = TRUE, sep =  ",")
  ALL_NCUSIP <- as.character(df_comp$NCUSIP)
  
  # loop through all RP ids:
  rp_ids <- unique(df_us$RP_ENTITY_ID)
  
  rp_match_data_manual <- rp_match_data <- NULL
  save_all_rp_cusip <- save_all_rp_cusip_manual <- list()
  k_all_rp_cupsip <- k_all_rp_cupsip_manual <- 1
  for (i in 1:length(rp_ids)){
    check.manually <- FALSE
    cat(paste0("rp id being processed: ", rp_ids[i], ". i : ", i ,"\n"))
    cusip_match <- name_match <- ticker_match <- 0
    i_rp_ids <- rp_ids[i]
    i_df <- df_us[df_us$RP_ENTITY_ID%in%i_rp_ids, ]
    i_NAME <- as.character(i_df[i_df$DATA_TYPE%in%"NAME",]$DATA_VALUE)
    i_NAME <- toupper(stringr::str_remove(i_NAME, "\\.$"))
    i_TICKER <- as.character(i_df[i_df$DATA_TYPE%in%"TICKER",]$DATA_VALUE)
    i_CUSIP <- as.character(i_df[i_df$DATA_TYPE%in%"CUSIP",]$DATA_VALUE)
    idx <- ALL_NCUSIP%in%i_CUSIP
    if (sum(idx)!=0){
      cusip_match <- 1
      i_CUSIP_found <- ALL_NCUSIP[idx]
    }
    i_CUSIP. <- str_sub(i_CUSIP, end=-2)
    idx <- ALL_NCUSIP%in%i_CUSIP.
    if (sum(idx)!=0){
      cusip_match <- 1
      i_CUSIP_found <- ALL_NCUSIP[idx]
    }
    if (cusip_match==0){
      tmp <- check.close.strings(ALL_NCUSIP,i_CUSIP)
      if (tmp$check==TRUE){
        cusip_match <- 1
        i_CUSIP_found <- tmp$res
        check.manually <- TRUE
        idx <- tmp$id
      }
    }
    if (cusip_match==1){
      idx2 <- idx3 <- FALSE
      i_data_comp <- df_comp[idx,]
      i_PERMNO <- i_data_comp$PERMNO
      if (length(i_PERMNO)>1){
        i_PERMNO <- get.unique(i_PERMNO)
      }
      i_NAME_comp <- as.character(i_data_comp$COMNAM)
      i_TICKER_comp <- as.character(i_data_comp$TICKER)
      tmp <- compare.vec(i_NAME_comp,i_NAME)
      idx2 <- tmp$check
      i_NAME <- tmp$out
      if (length(idx2)>1) {idx2 <- FALSE}
      if (isTRUE(idx2)){
        name_match <- 1
        i_NAME_found <- i_NAME
      }
      tmp <- FALSE
      for (q in 1:length(i_TICKER)){
        tmp <- all.equal.character(i_TICKER_comp,i_TICKER[q])
        if (isTRUE(tmp)){
          idx3 <- tmp
        }
      }
      i_TICKER_found <- ""
      if(isTRUE(idx3)){
        ticker_match <- 1
        i_TICKER_found <- i_TICKER
      }
      
      if(check.manually==FALSE){
        if(cusip_match*name_match==1){
          save_all_rp_cusip[[k_all_rp_cupsip]] <- i_CUSIP
          k_all_rp_cupsip <- k_all_rp_cupsip+1
          k <- length(i_CUSIP_found)
          if (length(i_PERMNO)==1) {PERMNO_store <- rep(i_PERMNO,k)} else {PERMNO_store <- i_PERMNO}
          i_rp_match_data <- data.frame(RP_id = rep(i_rp_ids,times=k),PERMNO = PERMNO_store,CUSIP = i_CUSIP_found,NAME = rep(i_NAME_found,k),TICKER = rep(i_TICKER_found,k))
          rp_match_data <- rbind(rp_match_data,i_rp_match_data)
        }
      } else {
        if(cusip_match*name_match==1){
          save_all_rp_cusip_manual[[k_all_rp_cupsip_manual]] <- i_CUSIP
          k_all_rp_cupsip_manual <- k_all_rp_cupsip_manual+1
          k <- length(i_CUSIP_found)
          if (length(i_PERMNO)==1) {PERMNO_store <- rep(i_PERMNO,k)} else {PERMNO_store <- i_PERMNO}
          i_rp_match_data <- data.frame(RP_id = rep(i_rp_ids,times=k),PERMNO = PERMNO_store,CUSIP = i_CUSIP_found,NAME = rep(i_NAME_found,k),TICKER = rep(i_TICKER_found,k))
          rp_match_data_manual <- rbind(rp_match_data_manual,i_rp_match_data)
        }
      }
      
      
    }
  }
  save(rp_match_data,save_all_rp_cusip,rp_match_data_manual,save_all_rp_cusip_manual,file = "rp_file_match_wrds.RData")
}

rm(list=ls())
source("help_functions.R")
load("rp_file_match_wrds.RData")

# remove duplicates:
idx <- !duplicated(rp_match_data$RP_id)
rp_match_data <- rp_match_data[idx, ]

idx <- !duplicated(rp_match_data_manual$RP_id)
rp_match_data_manual <- rp_match_data_manual[idx, ]

# remove duplicates in the other file:
load("wrds_file_match_rp_clean.RData")

idx <- !rp_match_data$RP_id%in%wrds_file_data$RP_id
rp_match_data <- rp_match_data[idx, ]
idx <- !rp_match_data_manual$RP_id%in%wrds_file_data$RP_id
rp_match_data_manual <- rp_match_data_manual[idx, ]

# save to csv to check manually:
write.csv(rp_match_data_manual, file = "rp_file_match_wrds_manual.csv")
rp_match_data_manual_clean <- read.csv(file = "rp_file_match_wrds_manual_clean.csv",sep = ";")
idx <- rp_match_data_manual_clean$CHECK_FINAL
rp_match_data_manual_clean <- rp_match_data_manual_clean[,-c(6:11)]
rp_match_data_manual_clean <- rp_match_data_manual_clean[which(idx==1),]


rp_match_data <- cbind(rp_match_data,rep(FALSE,times=dim(rp_match_data)[1]))
colnames(rp_match_data)[6] <- "IS MANUAL"
rp_match_data_manual_clean <- cbind(rp_match_data_manual_clean,rep(TRUE,times=dim(rp_match_data_manual_clean)[1]))
colnames(rp_match_data_manual_clean)[6] <- "IS MANUAL"

rp_file_data <- rbind(as.matrix(rp_match_data),as.matrix(rp_match_data_manual_clean))
rp_file_data <- as.data.frame(rp_file_data)
rownames(rp_file_data) <- 1:dim(rp_file_data)[1]


save(rp_file_data,file = "rp_file_match_rp_clean.RData")
