rm(list=ls())
# ------- SET WORKING DIRECTORY ------- #
if (! "rstudioapi" %in% installed.packages() ) install.packages("rstudioapi")
wd <- dirname(rstudioapi::getSourceEditorContext()$path)
setwd(wd)

load(file = "wrds_file_match_rp_clean.RData")
load(file = "rp_file_match_rp_clean.RData")

if (sum(rp_file_data$RP_id%in%wrds_file_data$RP_id)>0) {
  stop("RP ids duplicate in both files")
} else {
  cat("no duplicated RP ids")
}

rp_table <- rbind(rp_file_data,wrds_file_data)
colnames(rp_table)[6] <- "IS_MANUAL"


# added additional series after merging datasets:
# COCA-COLA ENTERPRISE: 	
tmp_table <- data.frame(RP_id = "E61E5B", PERMNO = "70500", CUSIP = "19122T10", NAME = "Coca cola enterprise", TICKER = "CCE", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# JAKKS PACIFIC: 	
tmp_table <- data.frame(RP_id = "5363A2", PERMNO = "83520", CUSIP = "47012E10", NAME = "JAKKS PACIFIC", TICKER = "JAKK", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# COCA-COLA: 	
tmp_table <- data.frame(RP_id = "EEA6B3", PERMNO = "11308", CUSIP = "191216100", NAME = "Coca cola co.", TICKER = "KO", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# FORD-MOTOR: 	
tmp_table <- data.frame(RP_id = "A6213D", PERMNO = "25785", CUSIP = "34537086", NAME = "FORD MOTOR", TICKER = "F", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# ALLEGHENY TELDYN:
tmp_table <- data.frame(RP_id = "D1173F", PERMNO = "43123", CUSIP = "43123", NAME = "ALLEGHENY TELDYN", TICKER = "ALS", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# BAKER HUGHES INC:
tmp_table <- data.frame(RP_id = "940C3D", PERMNO = "75034", CUSIP = "05722410", NAME = "BAKER HUGHES INC", TICKER = "BHI", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# CARLISLE COS:
tmp_table <- data.frame(RP_id = "9548BB", PERMNO = "27334", CUSIP = "14233910", NAME = "CARLISLE COS", TICKER = "CSL", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# DONNELLEY RR:
tmp_table <- data.frame(RP_id = "0BE0AE", PERMNO = "38682", CUSIP = "25786710", NAME = "DONNELLEY RR", TICKER = "RRD", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# ESTEE LAUDER COS:
tmp_table <- data.frame(RP_id = "14ED2B", PERMNO = "82642", CUSIP = "51843910", NAME = "ESTEE LAUDER COS", TICKER = "EL", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# ITT INDUS INC:
tmp_table <- data.frame(RP_id = "726EEA", PERMNO = "12570", CUSIP = "45091110", NAME = "ITT INDUS INC", TICKER = "ITT", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# KIMBERLY CLARK:
tmp_table <- data.frame(RP_id = "3DE4D1", PERMNO = "17750", CUSIP = "49436810", NAME = "KIMBERLY CLARK", TICKER = "KMB", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# PPG INDS:
tmp_table <- data.frame(RP_id = "39FB23", PERMNO = "22509", CUSIP = "69350610", NAME = "PPG INDS", TICKER = "PPG", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# PRAXAIR:
tmp_table <- data.frame(RP_id = "285175", PERMNO = "77768", CUSIP = "74005P10", NAME = "PRAXAIR", TICKER = "PX", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# RPM INTL INC:
tmp_table <- data.frame(RP_id = "F5D059", PERMNO = "65307", CUSIP = "74968510", NAME = "RPM INTL INC", TICKER = "RPM", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# Scotts Miracle-Gro Co:
tmp_table <- data.frame(RP_id = "F3FCC3", PERMNO = "77300", CUSIP = "81018610", NAME = "Scotts Miracle-Gro Co", TICKER = "SMG", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# US STEEL CORP:
tmp_table <- data.frame(RP_id = "4E2D94", PERMNO = "76644", CUSIP = "91290910", NAME = "US STEEL CORP", TICKER = "X", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# NABORS INDS:
tmp_table <- data.frame(RP_id = "E4E3B7", PERMNO = "29102", CUSIP = "G6359F10", NAME = "NABORS INDS", TICKER = "NBI", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# BP PLC:
tmp_table <- data.frame(RP_id = "2D469F", PERMNO = "29890", CUSIP = "05562210", NAME = "BP PLC", TICKER = "BP", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# CHEVRON CP:
tmp_table <- data.frame(RP_id = "D54E62", PERMNO = "14541", CUSIP = "16675110", NAME = "CHEVRON CP", TICKER = "CVX", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# HALLIBURTON:
tmp_table <- data.frame(RP_id = "2B49F4", PERMNO = "23819", CUSIP = "40621610", NAME = "HALLIBURTON", TICKER = "HAL", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# ST MARY LD & EXP:
tmp_table <- data.frame(RP_id = "6A3C35", PERMNO = "78170", CUSIP = "78454L10", NAME = "ST MARY LD & EXP", TICKER = "MR", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# PATTERSON ENERGY:
tmp_table <- data.frame(RP_id = "57356F", PERMNO = "79857", CUSIP = "70341410", NAME = "PATTERSON ENERGY", TICKER = "PTEN", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# ROWAN COS:
tmp_table <- data.frame(RP_id = "3FFA00", PERMNO = "45495", CUSIP = "G7665A10", NAME = "ROWAN COS", TICKER = "RDC", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# TRANSOCEAN LTD:
tmp_table <- data.frame(RP_id = "2DBC3B", PERMNO = "79237", CUSIP = "H8817H10", NAME = "TRANSOCEAN LTD", TICKER = "RIG", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# SCHLUMBERGER LTD:
tmp_table <- data.frame(RP_id = "164D72", PERMNO = "14277", CUSIP = "80685710", NAME = "SCHLUMBERGER LTD", TICKER = "SLB", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# CA Technologies Inc:
tmp_table <- data.frame(RP_id = "76DE40", PERMNO = "25778", CUSIP = "12673P10", NAME = "CA Technologies Inc", TICKER = "CA", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# CHECK POINT SFWR:
tmp_table <- data.frame(RP_id = "531EF1", PERMNO = "83639", CUSIP = "M2246510", NAME = "CHECK POINT SFWR", TICKER = "CHKP", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# AMDOCS LTD:
tmp_table <- data.frame(RP_id = "45D153", PERMNO = "86144", CUSIP = "G0260210", NAME = "AMDOCS LTD", TICKER = "DOX", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# FLEXTRONICS INTL:
tmp_table <- data.frame(RP_id = "B4E00D", PERMNO = "80329", CUSIP = "Y2573F10", NAME = "FLEXTRONICS INTL", TICKER = "FLEX", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# HEWLETT-PACKARD:
tmp_table <- data.frame(RP_id = "4AC91D", PERMNO = "27828", CUSIP = "40434L10", NAME = "HEWLETT-PACKARD", TICKER = "HPQ", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# IBM:
tmp_table <- data.frame(RP_id = "8D4486", PERMNO = "12490", CUSIP = "45920010", NAME = "IBM", TICKER = "IBM", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# INTEGRATED DEVICE:
tmp_table <- data.frame(RP_id = "8A957F", PERMNO = "44506", CUSIP = "45811810", NAME = "INTEGRATED DEVICE", TICKER = "IDTI", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# INGERSOLL-RAND:
tmp_table <- data.frame(RP_id = "5A6336", PERMNO = "12431", CUSIP = "G4776G10", NAME = "INGERSOLL-RAND", TICKER = "IR", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# NOKIA CORP:
tmp_table <- data.frame(RP_id = "C12ED9", PERMNO = "87128", CUSIP = "65490220", NAME = "NOKIA CORP", TICKER = "NOK", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# ORBOTECH:
tmp_table <- data.frame(RP_id = "290820", PERMNO = "78527", CUSIP = "M7525310", NAME = "ORBOTECH", TICKER = "ORB", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# OPEN TEXT:
tmp_table <- data.frame(RP_id = "34E891", PERMNO = "82833", CUSIP = "68371510", NAME = "OPEN TEXT", TICKER = "OTC", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# PTC INC:
tmp_table <- data.frame(RP_id = "D437C3", PERMNO = "75912", CUSIP = "69370C10", NAME = "PTC INC", TICKER = "PMTC", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# AT&T:
tmp_table <- data.frame(RP_id = "251988", PERMNO = "66093", CUSIP = "00206R10", NAME = "AT&T", TICKER = "ATTA", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# CROWN CASTLE:
tmp_table <- data.frame(RP_id = "275300", PERMNO = "86339", CUSIP = "22822V10", NAME = "CROWN CASTLE", TICKER = "CCI", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# AMERN EAGLE OUTF:
tmp_table <- data.frame(RP_id = "2CC60C", PERMNO = "80432", CUSIP = "02553E10", NAME = "AMERN EAGLE OUTF", TICKER = "AEO", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# CRACKER BARREL O:
tmp_table <- data.frame(RP_id = "3B50FE", PERMNO = "27562", CUSIP = "22410J10", NAME = "CRACKER BARREL O", TICKER = "CBRL", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# COSTCO WHOLESALE:
tmp_table <- data.frame(RP_id = "B8EF97", PERMNO = "87055", CUSIP = "22160K10", NAME = "COSTCO WHOLESALE", TICKER = "COST", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# CHICO'S FAS:
tmp_table <- data.frame(RP_id = "1D3A00", PERMNO = "78963", CUSIP = "16861510", NAME = "CHICO'S FAS", TICKER = "CHS", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# COLUMBIA SPTSWR:
tmp_table <- data.frame(RP_id = "5D0337", PERMNO = "85863", CUSIP = "19851610", NAME = "COLUMBIA SPTSWR", TICKER = "COLM", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# DILLARD INC:
tmp_table <- data.frame(RP_id = "4ECD1A", PERMNO = "49429", CUSIP = "25406710", NAME = "DILLARD INC", TICKER = "DDS", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# TARGET
tmp_table <- data.frame(RP_id = "F6DCE4", PERMNO = "49154", CUSIP = "87612E10", NAME = "TARGET", TICKER = "TGT", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# MACY'S INC
tmp_table <- data.frame(RP_id = "C5C137", PERMNO = "77462", CUSIP = "55616P10", NAME = "MACY'S INC", TICKER = "M", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# W W GRAINGER
tmp_table <- data.frame(RP_id = "6EB9DA", PERMNO = "52695", CUSIP = "8480210", NAME = "W W GRAINGER", TICKER = "GWW", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# HOME DEPOT
tmp_table <- data.frame(RP_id = "ACDF88", PERMNO = "66181", CUSIP = "43707610", NAME = "HOME DEPOT", TICKER = "HD", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# JC PENNEY
tmp_table <- data.frame(RP_id = "A1A1AF", PERMNO = "18403", CUSIP = "70816010", NAME = "JC PENNEY", TICKER = "JCP", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# KOHLS
tmp_table <- data.frame(RP_id = "0F0440", PERMNO = "77606", CUSIP = "50025510", NAME = "KOHLS", TICKER = "KSS", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# LOWES CO
tmp_table <- data.frame(RP_id = "76E80F", PERMNO = "61399", CUSIP = "54866110", NAME = "LOWES CO", TICKER = "LOW", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# MCDONALDS CP
tmp_table <- data.frame(RP_id = "954E30", PERMNO = "43449", CUSIP = "58013510", NAME = "MCDONALDS CP", TICKER = "MCD", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# MSC INDUSTRIAL
tmp_table <- data.frame(RP_id = "74E288", PERMNO = "82777", CUSIP = "55353010", NAME = "MSC INDUSTRIAL", TICKER = "MSM", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# PIER 1 IMPORTS
tmp_table <- data.frame(RP_id = "170A6F", PERMNO = "51692", CUSIP = "72027910", NAME = "PIER 1 IMPORTS", TICKER = "PIR", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# TIFFANY AND COM
tmp_table <- data.frame(RP_id = "FD5C77", PERMNO = "75100", CUSIP = "88654710", NAME = "TIFFANY AND COMP", TICKER = "TIF", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# WILLIAMS-SONOMA
tmp_table <- data.frame(RP_id = "F748C7", PERMNO = "83011", CUSIP = "96990410", NAME = "WILLIAMS-SONOMA", TICKER = "WSM", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# TJX COMPANIES
tmp_table <- data.frame(RP_id = "40B903", PERMNO = "40539", CUSIP = "87254010", NAME = "TJX COMPANIES", TICKER = "TJX", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# BRISTOL-MYERS SQ
tmp_table <- data.frame(RP_id = "94637C", PERMNO = "19393", CUSIP = "11012210", NAME = "BRISTOL-MYERS SQ", TICKER = "BMY", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# ELI LILLY
tmp_table <- data.frame(RP_id = "F30508", PERMNO = "50876", CUSIP = "53245710", NAME = "ELI LILLY", TICKER = "LLY", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# MCKESSON 
tmp_table <- data.frame(RP_id = "4A5C8D", PERMNO = "81061", CUSIP = "58155Q10", NAME = "MCKESSON", TICKER = "MCK", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# MERCK & CO., INC
tmp_table <- data.frame(RP_id = "1EBF8D", PERMNO = "22752", CUSIP = "58933Y10", NAME = "MERCK & CO. INC", TICKER = "MERC", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# RESMED 
tmp_table <- data.frame(RP_id = "434F38", PERMNO = "81736", CUSIP = "76115210", NAME = "RESMED", TICKER = "RMD", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# ALLIANCEBERNSTEI
tmp_table <- data.frame(RP_id = "CB138D", PERMNO = "75278", CUSIP = "01881G10", NAME = "ALLIANCEBERNSTEI", TICKER = "AB", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# MANPOWERGROUP IN
tmp_table <- data.frame(RP_id = "C0200F", PERMNO = "75285", CUSIP = "56418H10", NAME = "MANPOWERGROUP IN", TICKER = "MAN", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# CARNIVAL CP
tmp_table <- data.frame(RP_id = "67779", PERMNO = "75154", CUSIP = "14365830", NAME = "CARNIVAL CP", TICKER = "CCL", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# C.H. ROBINSON WW
tmp_table <- data.frame(RP_id = "C659EB", PERMNO = "85459", CUSIP = "12541W20", NAME = "C.H. ROBINSON WW", TICKER = "CHRW", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# CIGNA 
tmp_table <- data.frame(RP_id = "86A1B9", PERMNO = "64186", CUSIP = "12550910", NAME = "CIGNA", TICKER = "CI", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# WALT DISNEY 
tmp_table <- data.frame(RP_id = "A18D3C", PERMNO = "26403", CUSIP = "25468710", NAME = "WALT DISNEY", TICKER = "WAL", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# DR HORTON
tmp_table <- data.frame(RP_id = "06EF42", PERMNO = "77661", CUSIP = "23331A10", NAME = "DR HORTON", TICKER = "DHI", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# E-TRADE GROUP
tmp_table <- data.frame(RP_id = "28DEFA", PERMNO = "83862", CUSIP = "26924610", NAME = "E-TRADE GROUP", TICKER = "ETFC", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# REGIONS FINL COR
tmp_table <- data.frame(RP_id = "73C521", PERMNO = "35044", CUSIP = "7591EP10", NAME = "REGIONS FINL COR", TICKER = "RF", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# M & T BANK CORP
tmp_table <- data.frame(RP_id = "D1AE3B", PERMNO = "35554", CUSIP = "55261F10", NAME = "M & T BANK CORP", TICKER = "MTB", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# FEDERATED INVEST
tmp_table <- data.frame(RP_id = "73C9E2", PERMNO = "86102", CUSIP = "31421110", NAME = "FEDERATED INVEST", TICKER = "FII", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# HARTFORD FIN SER 
tmp_table <- data.frame(RP_id = "766047", PERMNO = "82775", CUSIP = "41651510", NAME = "HARTFORD FIN SER", TICKER = "HGH", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# HUNT JB TRANSP
tmp_table <- data.frame(RP_id = "72DF04", PERMNO = "42877", CUSIP = "44565810", NAME = "HUNT JB TRANSP", TICKER = "JBHT", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# KNIGHT TRANSPORT 
tmp_table <- data.frame(RP_id = "ED9576", PERMNO = "80987", CUSIP = "49906410", NAME = "KNIGHT TRANSPORT", TICKER = "KNX", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# MDU RSRCS GROUP
tmp_table <- data.frame(RP_id = "135B09", PERMNO = "23835", CUSIP = "55269010", NAME = "MDU RSRCS GROUP", TICKER = "MDU", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# MGM MIRAGE
tmp_table <- data.frame(RP_id = "8E8E6E", PERMNO = "11891", CUSIP = "55295310", NAME = "MGM MIRAGE", TICKER = "MGM", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# MARRIOTT INTL 
tmp_table <- data.frame(RP_id = "385DD4", PERMNO = "85913", CUSIP = "57190320", NAME = "MARRIOTT INTL", TICKER = "MAR", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# MARSH & MCLENNAN
tmp_table <- data.frame(RP_id = "9B5968", PERMNO = "45751", CUSIP = "57174810", NAME = "MARSH & MCLENNAN", TICKER = "MMC", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# MGIC INVT CORP W
tmp_table <- data.frame(RP_id = "E28F22", PERMNO = "76804", CUSIP = "55284810", NAME = "MGIC INVT CORP W", TICKER = "MTG", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# WELLS FARGO
tmp_table <- data.frame(RP_id = "E8846E", PERMNO = "38703", CUSIP = "94974610", NAME = "WELLS FARGO", TICKER = "WFC", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# PEOPLES UNI
tmp_table <- data.frame(RP_id = "449A26", PERMNO = "12073", CUSIP = "71270410", NAME = "PEOPLES UNI", TICKER = "PBCT", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# PULTEGROUP
tmp_table <- data.frame(RP_id = "7D5FD6", PERMNO = "54148", CUSIP = "74586710", NAME = "PULTEGROUP", TICKER = "PHM", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# PNC FINL SVC 
tmp_table <- data.frame(RP_id = "61B81B", PERMNO = "60442", CUSIP = "69347510", NAME = "PNC FINL SVC", TICKER = "PNC", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# POTASH CORP SASK
tmp_table <- data.frame(RP_id = "FFBF74", PERMNO = "75844", CUSIP = "73755L10", NAME = "POTASH CORP SASK", TICKER = "POT", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# ROYAL CARIBBEAN
tmp_table <- data.frame(RP_id = "751A74", PERMNO = "79145", CUSIP = "V7780T10", NAME = "ROYAL CARIBBEAN", TICKER = "RCL", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# RENT-A-CENTER
tmp_table <- data.frame(RP_id = "C4FBDC", PERMNO = "81222", CUSIP = "76009N10", NAME = "RENT-A-CENTER", TICKER = "RCII", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# CHARLES SCHWAB
tmp_table <- data.frame(RP_id = "D33D8C", PERMNO = "75186", CUSIP = "80851310", NAME = "CHARLES SCHWAB", TICKER = "SCHW", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# BB&T CP
tmp_table <- data.frame(RP_id = "1A3E1B", PERMNO = "71563", CUSIP = "05493710", NAME = "BB&T CP", TICKER = "BBT", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# TRAVELERS
tmp_table <- data.frame(RP_id = "E206B0", PERMNO = "59459", CUSIP = "89417E10", NAME = "TRAVELERS", TICKER = "TRV", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# TYCO INTL/JOHNSON CNTRLS
tmp_table <- data.frame(RP_id = "99333F", PERMNO = "45356", CUSIP = "G5150210", NAME = "TYCO INTL/JOHNSON CNTRLS", TICKER = "TYC", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)
# WESTAMERICA
tmp_table <- data.frame(RP_id = "622037", PERMNO = "82107", CUSIP = "95709010", NAME = "WESTAMERICA", TICKER = "WABC", IS_MANUAL = TRUE)
rp_table <- rbind(rp_table,tmp_table)

save(rp_table, file = "rp_permno_link_table.RData")