rm(list=ls())
# ------- SET WORKING DIRECTORY ------- #
if (! "rstudioapi" %in% installed.packages() ) install.packages("rstudioapi")
wd <- dirname(rstudioapi::getSourceEditorContext()$path)
setwd(wd)


require(lubridate)
do.sort.dates <- FALSE 
do.sort.rps <- TRUE


# map function to [-1, 1]
map2unit <- function(vec.in){
  vec.out <- vec.in - 50
  vec.out <- vec.out/50
  vec.out
}

# load rp-permno link table:
# take all RP ids: 
rp_ids_all <- c("2D469F","34E891","45D153","531EF1","1981BF","67779","290820","B4E00D","C12ED9","FFBF74")
n_rp <- length(rp_ids_all)

relevance_constr <-  novelty_constr <- TRUE

load("rp_permno_link_table.RData")
load("final_dates.RData")
for (i_nrp in seq(n_rp)){
  sent_data <- earn_sent_data <- NULL 
  i_rp_id <- as.character(rp_ids_all[i_nrp])
  # loop through rp_id
    dj_i.df <- read.csv(paste0("csv/",i_rp_id,".csv"))
    dj_i.df$RP_ENTITY_ID <- rep(as.character(rp_ids_all[i_nrp]),times = dim(dj_i.df)[1])
    i_years_final_dates <- as.Date(years_final_date)
    
    i_nrp_sent_data <- i_nrp_earn_sent_data <- matrix(NaN,nrow=length(i_years_final_dates),ncol=1+13+3) #1-dates, 3 (2,3,4,5,6,7,8,9,10,11,12,13,14)-thirteen sentiment values averaged over the day,  3 (15,16,17)-rp-id;permno;is-manually-check
    i_nrp_sent_data[,1] <- i_nrp_earn_sent_data[,1] <- as.character(i_years_final_dates)
    k <- length(i_years_final_dates)
    cat(paste0("looping through RP id. current = ", i_rp_id, " = remaining to sort = ", n_rp-i_nrp+1,"\n"))
    
    i_nrp_sent_data[,15] <- rep(i_rp_id, times = k)
    i_nrp_sent_data[,16] <- rep(as.character(rp_table[rp_table$RP_id%in%i_rp_id, ]$PERMNO), times = k)
    i_nrp_sent_data[,17] <- rep(as.logical(rp_table[rp_table$RP_id%in%i_rp_id, ]$`IS_MANUAL`), times = k)
    #i_nrp_sent_data <- as.data.frame(i_nrp_sent_data)
    colnames(i_nrp_sent_data) <- c("DATE","ESS","AES","AEV","CSS","NIP","PEQ","BEE","BMQ","BAM","BCA","BER","ANL_CHG","MCQ","RP-ID","PERMNO","IS-MANUAL")
    
    i_nrp_earn_sent_data[,15] <- rep(i_rp_id, times = k)
    i_nrp_earn_sent_data[,16] <- rep(as.character(rp_table[rp_table$RP_id%in%i_rp_id, ]$PERMNO), times = k)
    i_nrp_earn_sent_data[,17] <- rep(as.logical(rp_table[rp_table$RP_id%in%i_rp_id, ]$`IS_MANUAL`), times = k)
    #i_nrp_earn_sent_data <- as.data.frame(i_nrp_earn_sent_data)
    colnames(i_nrp_earn_sent_data) <- c("DATE","ESS","AES","AEV","CSS","NIP","PEQ","BEE","BMQ","BAM","BCA","BER","ANL_CHG","MCQ","RP-ID","PERMNO","IS-MANUAL")
    
    #=======================
    # DJ edition data
    #=======================
    
    # get i_nrp data for i_djyears year:
    dj_i_inrp_df <- dj_i.df[dj_i.df$RP_ENTITY_ID%in%i_rp_id, ] 
    # take only relevant info:
    if (relevance_constr){
      dj_i_inrp_df <- dj_i_inrp_df[dj_i_inrp_df$RELEVANCE>=75, ]
    }
    # take only first news info:
    if (novelty_constr){
      dj_i_inrp_df <- dj_i_inrp_df[dj_i_inrp_df$ENS>=100, ]
    }
    # get the dates:
    dj_i_inrp_dates <- as_date(as.character(dj_i_inrp_df$RPNA_DATE_UTC),"%Y%m%d")
    # get earnings sentiments:
    earn_dj_i_inrp_df <- dj_i_inrp_df[dj_i_inrp_df$GROUP%in%"earnings", ]
    # get the dates:
    earn_dj_i_inrp_dates <- as_date(as.character(earn_dj_i_inrp_df$RPNA_DATE_UTC),"%Y%m%d")
    dj_tmpdates <- unique(dj_i_inrp_dates)
    earn_dj_tmpdates <- unique(earn_dj_i_inrp_dates)
    dj_tmpdates <- dj_tmpdates[!is.na(dj_tmpdates)]
    all_tmpdates <- dj_tmpdates
    earn_all_tmpdates <- earn_dj_tmpdates
    # ALL SENTIMENTS
      for (q_all_tmpdates in 1:length(all_tmpdates)){
        cat(paste0("percent left: ", round((1-q_all_tmpdates/length(all_tmpdates))*100,2),"\n"))
        # INITIALIZE STORAGE
        q_store_ess <- q_store_aes <- q_store_aev <- NULL
        q_store_css <- q_store_nip <- q_store_peq <-  NULL
        q_store_bee <- q_store_bmq <- q_store_bam <- NULL
        q_store_bca <- q_store_ber <- q_store_anl_chg <- NULL
        q_store_mcq <- NULL
        # CHECK IF DJ EDITION HAS THE DATA
        dj_idx <- as_date(as.character(dj_i_inrp_df$RPNA_DATE_UTC),"%Y%m%d")%in%all_tmpdates[q_all_tmpdates]
        if (sum(dj_idx)!=0){
          # STORE THE DJ EDITION DATA
          q_store_ess <- c(q_store_ess,map2unit(dj_i_inrp_df[dj_idx, ]$ESS))
          q_store_aes <- c(q_store_aes,map2unit(dj_i_inrp_df[dj_idx, ]$AES))
          q_store_aev <- c(q_store_aev,dj_i_inrp_df[dj_idx, ]$AEV)
          
          q_store_css <- c(q_store_css,map2unit(dj_i_inrp_df[dj_idx, ]$CSS))
          q_store_nip <- c(q_store_nip,map2unit(dj_i_inrp_df[dj_idx, ]$NIP))
          q_store_peq <- c(q_store_peq,map2unit(dj_i_inrp_df[dj_idx, ]$PEQ))
          q_store_bee <- c(q_store_bee,map2unit(dj_i_inrp_df[dj_idx, ]$BEE))
          q_store_bmq <- c(q_store_bmq,map2unit(dj_i_inrp_df[dj_idx, ]$BMQ))
          q_store_bam <- c(q_store_bam,map2unit(dj_i_inrp_df[dj_idx, ]$BAM))
          q_store_bca <- c(q_store_bca,map2unit(dj_i_inrp_df[dj_idx, ]$BCA)) 
          q_store_ber <- c(q_store_ber,map2unit(dj_i_inrp_df[dj_idx, ]$BER)) 
          q_store_anl_chg <- c(q_store_anl_chg,map2unit(dj_i_inrp_df[dj_idx, ]$ANL_CHG)) 
          q_store_mcq <- c(q_store_mcq,map2unit(dj_i_inrp_df[dj_idx, ]$MCQ)) 
        }
        # COMPUTE MEAN VALUES
        q_ess <- mean(as.double(q_store_ess), na.rm = T)
        q_aes <- mean(as.double(q_store_aes), na.rm = T)
        q_aev <- mean(as.double(q_store_aev), na.rm = T)
        
        q_css <- mean(as.double(q_store_css), na.rm = T)
        q_nip <- mean(as.double(q_store_nip), na.rm = T)
        q_peq <- mean(as.double(q_store_peq), na.rm = T)
        q_bee <- mean(as.double(q_store_bee), na.rm = T)
        q_bmq <- mean(as.double(q_store_bmq), na.rm = T)
        q_bam <- mean(as.double(q_store_bam), na.rm = T)
        q_bca <- mean(as.double(q_store_bam), na.rm = T)
        q_ber <- mean(as.double(q_store_ber), na.rm = T)
        q_anl_chg <- mean(as.double(q_store_anl_chg), na.rm = T)
        q_mcq <- mean(as.double(q_store_mcq), na.rm = T)
        
        q_date <- all_tmpdates[q_all_tmpdates]
        # STORE IN APPROPRIATE DATE
        i_nrp_sent_data[i_years_final_dates%in%q_date, 2] <- q_ess
        i_nrp_sent_data[i_years_final_dates%in%q_date, 3] <- q_aes
        i_nrp_sent_data[i_years_final_dates%in%q_date, 4] <- q_aev
        
        i_nrp_sent_data[i_years_final_dates%in%q_date, 5] <- q_css
        i_nrp_sent_data[i_years_final_dates%in%q_date, 6] <- q_nip
        i_nrp_sent_data[i_years_final_dates%in%q_date, 7] <- q_peq
        i_nrp_sent_data[i_years_final_dates%in%q_date, 8] <- q_bee
        i_nrp_sent_data[i_years_final_dates%in%q_date, 9] <- q_bmq
        i_nrp_sent_data[i_years_final_dates%in%q_date, 10] <- q_bam
        i_nrp_sent_data[i_years_final_dates%in%q_date, 11] <- q_bca
        i_nrp_sent_data[i_years_final_dates%in%q_date, 12] <- q_ber
        i_nrp_sent_data[i_years_final_dates%in%q_date, 13] <- q_anl_chg
        i_nrp_sent_data[i_years_final_dates%in%q_date, 14] <- q_mcq
      } # end of loop; all
      # ONLY EARNINGS GROUP SENTIMENTS
      for (q_earn_all_tmpdates in 1:length(earn_all_tmpdates)){
        # INITIALIZE STORAGE
        q_earn_store_ess <- q_earn_store_aes <- q_earn_store_aev <- NULL
        q_earn_store_css <- q_earn_store_nip <- q_earn_store_peq <-  NULL
        q_earn_store_bee <- q_earn_store_bmq <- q_earn_store_bam <- NULL
        q_earn_store_bca <- q_earn_store_ber <- q_earn_store_anl_chg <- NULL
        q_earn_store_mcq <- NULL
        # CHECK IF DJ EDITION HAS THE DATA
        earn_dj_idx <- as_date(as.character(earn_dj_i_inrp_df$RPNA_DATE_UTC),"%Y%m%d")%in%earn_all_tmpdates[q_earn_all_tmpdates]
        if (sum(earn_dj_idx)!=0){
          # STORE THE DJ EDITION DATA
          q_earn_store_ess <- c(q_earn_store_ess,map2unit(earn_dj_i_inrp_df[earn_dj_idx, ]$ESS))
          q_earn_store_aes <- c(q_earn_store_aes,map2unit(earn_dj_i_inrp_df[earn_dj_idx, ]$AES))
          q_earn_store_aev <- c(q_earn_store_aev,earn_dj_i_inrp_df[earn_dj_idx, ]$AEV)
          
          q_earn_store_css <- c(q_earn_store_css,map2unit(earn_dj_i_inrp_df[earn_dj_idx, ]$CSS))
          q_earn_store_nip <- c(q_earn_store_nip,map2unit(earn_dj_i_inrp_df[dj_idx, ]$NIP))
          q_earn_store_peq <- c(q_earn_store_peq,map2unit(earn_dj_i_inrp_df[earn_dj_idx, ]$PEQ))
          q_earn_store_bee <- c(q_earn_store_bee,map2unit(earn_dj_i_inrp_df[earn_dj_idx, ]$BEE))
          q_earn_store_bmq <- c(q_earn_store_bmq,map2unit(earn_dj_i_inrp_df[earn_dj_idx, ]$BMQ))
          q_earn_store_bam <- c(q_earn_store_bam,map2unit(earn_dj_i_inrp_df[earn_dj_idx, ]$BAM))
          q_earn_store_bca <- c(q_earn_store_bca,map2unit(earn_dj_i_inrp_df[earn_dj_idx, ]$BCA)) 
          q_earn_store_ber <- c(q_earn_store_ber,map2unit(earn_dj_i_inrp_df[earn_dj_idx, ]$BER)) 
          q_earn_store_anl_chg <- c(q_earn_store_anl_chg,map2unit(earn_dj_i_inrp_df[earn_dj_idx, ]$ANL_CHG)) 
          q_earn_store_mcq <- c(q_earn_store_mcq,map2unit(earn_dj_i_inrp_df[earn_dj_idx, ]$MCQ)) 
        }
        # COMPUTE MEAN VALUES
        q_earn_ess <- mean(as.double(q_earn_store_ess), na.rm = T)
        q_earn_aes <- mean(as.double(q_earn_store_aes), na.rm = T)
        q_earn_aev <- mean(as.double(q_earn_store_aev), na.rm = T)
        
        q_earn_css <- mean(as.double(q_earn_store_css), na.rm = T)
        q_earn_nip <- mean(as.double(q_earn_store_nip), na.rm = T)
        q_earn_peq <- mean(as.double(q_earn_store_peq), na.rm = T)
        q_earn_bee <- mean(as.double(q_earn_store_bee), na.rm = T)
        q_earn_bmq <- mean(as.double(q_earn_store_bmq), na.rm = T)
        q_earn_bam <- mean(as.double(q_earn_store_bam), na.rm = T)
        q_earn_bca <- mean(as.double(q_earn_store_bam), na.rm = T)
        q_earn_ber <- mean(as.double(q_earn_store_ber), na.rm = T)
        q_earn_anl_chg <- mean(as.double(q_earn_store_anl_chg), na.rm = T)
        q_earn_mcq <- mean(as.double(q_earn_store_mcq), na.rm = T)
        
        q_earn_date <- earn_all_tmpdates[q_earn_all_tmpdates]
        # STORE IN APPROPRIATE DATE
        i_nrp_earn_sent_data[i_years_final_dates%in%q_earn_date, 2] <- q_earn_ess
        i_nrp_earn_sent_data[i_years_final_dates%in%q_earn_date, 3] <- q_earn_aes
        i_nrp_earn_sent_data[i_years_final_dates%in%q_earn_date, 4] <- q_earn_aev
        
        i_nrp_earn_sent_data[i_years_final_dates%in%q_earn_date, 5] <- q_earn_css
        i_nrp_earn_sent_data[i_years_final_dates%in%q_earn_date, 6] <- q_earn_nip
        i_nrp_earn_sent_data[i_years_final_dates%in%q_earn_date, 7] <- q_earn_peq
        i_nrp_earn_sent_data[i_years_final_dates%in%q_earn_date, 8] <- q_earn_bee
        i_nrp_earn_sent_data[i_years_final_dates%in%q_earn_date, 9] <- q_earn_bmq
        i_nrp_earn_sent_data[i_years_final_dates%in%q_earn_date, 10] <- q_earn_bam
        i_nrp_earn_sent_data[i_years_final_dates%in%q_earn_date, 11] <- q_earn_bca
        i_nrp_earn_sent_data[i_years_final_dates%in%q_earn_date, 12] <- q_earn_ber
        i_nrp_earn_sent_data[i_years_final_dates%in%q_earn_date, 13] <- q_earn_anl_chg
        i_nrp_earn_sent_data[i_years_final_dates%in%q_earn_date, 14] <- q_earn_mcq
        
      } # end of loop; earnings
    sent_data <- i_nrp_sent_data
    earn_sent_data <- i_nrp_earn_sent_data
    rm(i_nrp_sent_data,i_nrp_earn_sent_data)
  
  save(sent_data,earn_sent_data, file = paste0(getwd(),"/rp_data_new/",as.character(i_rp_id),".RData"))
  rm(sent_data,earn_sent_data)
} # end of loop; i_nrp


