# load data: 
load("ibes_crsp_data.RData")
ticker <- as.character(unique(ibes_crsp_data$ticker))
pe_ratio_ibes_crsp <- data.frame()
thresh1 <- 0.1

store_ticker_impute <- NULL
for (n_ticker in seq(length(ticker))){
  i_ticker <- ticker[n_ticker]
  cat(paste0("sorting ", i_ticker, " ticker. left: ",round((1-n_ticker/length(ticker))*100,2),  "%","\n"))
  i_ibes_crsp_data <- ibes_crsp_data[ibes_crsp_data$ticker%in%i_ticker,]
  t <- dim(i_ibes_crsp_data)[1]
  
  eps_sum_actual <- eps_sum_mean_h0 <- eps_sum_median_h0 <- eps_sum_mean_h1 <- eps_sum_median_h1 <- rep(NA,times=t)
  pe_ttm_actual <- pe_ttm_actual_announce <- pe_ttm_mean_h0 <- pe_ttm_median_h0 <- pe_ttm_mean_h1 <- pe_ttm_median_h1 <- rep(NA,times=t) 
  pe_ttm_actual_date <- pe_h0_date <- pe_h1_date <- rep(NA,times=t)
  # for (q in 1:(t-3)){
  #   
  #   # index for rolling 4quarters:
  #   idx <- q:(q+3)
  #   # actual PE ratio:
  #   pe_ttm_actual_date[q+3] <- i_ibes_crsp_data$crsp_date_h0[idx[length(idx)]]
  #   sum_eps <- sum(i_ibes_crsp_data$eps[idx])
  #   eps_sum_actual[q+3] <- sum_eps
  #   pe_ttm_actual[q+3] <- i_ibes_crsp_data$prc_h0[idx[length(idx)]]/(sum_eps)
  #   pe_ttm_actual_announce[q+3] <- i_ibes_crsp_data$prc_announce[idx[length(idx)]]/(sum_eps)
  # 
  #   if (abs(sum_eps)<=thresh1){
  #     pe_ttm_actual[q+3] <- i_ibes_crsp_data$prc_h0[idx[length(idx)]]/thresh1
  #     pe_ttm_actual_announce[q+3] <- i_ibes_crsp_data$prc_announce[idx[length(idx)]]/thresh1
  #   }
  #   # nowcasted PE ratio:
  #   pe_h0_date[q+3] <- i_ibes_crsp_data$crsp_date_h0[idx[length(idx)]]
  #   # mean consensus:
  #   sum_eps_mean_h0 <- sum(i_ibes_crsp_data$eps[idx[-length(idx)]]) + i_ibes_crsp_data$mean_forecast_h0[idx[length(idx)]]
  #   eps_sum_mean_h0[q+3] <- sum_eps_mean_h0
  #   pe_ttm_mean_h0[q+3] <- i_ibes_crsp_data$prc_h0[idx[length(idx)]]/(sum_eps_mean_h0)
  #   if (abs(sum_eps_mean_h0)<=thresh1){
  #     pe_ttm_mean_h0[q+3] <- i_ibes_crsp_data$prc_h0[idx[length(idx)]]/thresh1
  #   }
  #   # median consensus:
  #   sum_eps_median_h0 <- sum(i_ibes_crsp_data$eps[idx[-length(idx)]]) + i_ibes_crsp_data$median_forecast_h0[idx[length(idx)]]
  #   eps_sum_median_h0[q+3] <- sum_eps_median_h0
  #   pe_ttm_median_h0[q+3] <- i_ibes_crsp_data$prc_h0[idx[length(idx)]]/(sum_eps_median_h0)
  #   if (abs(sum_eps_median_h0)<=thresh1){
  #     pe_ttm_median_h0[q+3] <- i_ibes_crsp_data$prc_h0[idx[length(idx)]]/thresh1
  #   }
  #   # forecasted PE ratio:
  #   pe_h1_date[q+3] <- i_ibes_crsp_data$crsp_date_h1[idx[length(idx)]]
  #   # mean consensus:
  #   sum_eps_mean_h1 <- sum(i_ibes_crsp_data$eps[idx[-length(idx)]]) + i_ibes_crsp_data$mean_forecast_h1[idx[length(idx)]]
  #   eps_sum_mean_h1[q+3] <- sum_eps_mean_h1
  #   pe_ttm_mean_h1[q+3] <- i_ibes_crsp_data$prc_h1[idx[length(idx)]]/(sum_eps_mean_h1)
  #   if (abs(sum_eps_mean_h1)<=thresh1){
  #     pe_ttm_mean_h1[q+3] <- i_ibes_crsp_data$prc_h1[idx[length(idx)]]/thresh1
  #   }
  #   # median consesus:
  #   sum_eps_median_h1 <- sum(i_ibes_crsp_data$eps[idx[-length(idx)]]) + i_ibes_crsp_data$median_forecast_h1[idx[length(idx)]]
  #   eps_sum_median_h1[q+3] <- sum_eps_median_h1
  #   pe_ttm_median_h1[q+3] <- i_ibes_crsp_data$prc_h1[idx[length(idx)]]/(sum_eps_median_h1)
  #   if (abs(sum_eps_median_h1)<=thresh1){
  #     pe_ttm_median_h1[q+3] <- i_ibes_crsp_data$prc_h1[idx[length(idx)]]/thresh1
  #   }
  # }
  
  pe_ttm_actual <- i_ibes_crsp_data$prc_h0/i_ibes_crsp_data$eps
  pe_ttm_actual_announce <- i_ibes_crsp_data$prc_announce/i_ibes_crsp_data$eps
  pe_ttm_actual[abs(i_ibes_crsp_data$eps)<=thresh1] <- i_ibes_crsp_data$prc_h0[abs(i_ibes_crsp_data$eps)<=thresh1]/thresh1*sign(i_ibes_crsp_data$eps[abs(i_ibes_crsp_data$eps)<=thresh1])
  pe_ttm_actual_announce[abs(i_ibes_crsp_data$eps)<=thresh1] <- i_ibes_crsp_data$prc_announce[abs(i_ibes_crsp_data$eps)<=thresh1]/thresh1*sign(i_ibes_crsp_data$eps[abs(i_ibes_crsp_data$eps)<=thresh1])
  
  pe_ttm_mean_h0 <- i_ibes_crsp_data$prc_h0/i_ibes_crsp_data$mean_forecast_h0
  pe_ttm_mean_h0[abs(i_ibes_crsp_data$mean_forecast_h0)<=thresh1] <- i_ibes_crsp_data$prc_h0[abs(i_ibes_crsp_data$mean_forecast_h0)<=thresh1]/thresh1*sign(i_ibes_crsp_data$mean_forecast_h0[abs(i_ibes_crsp_data$mean_forecast_h0)<=thresh1])
  
  pe_ttm_median_h0 <- i_ibes_crsp_data$prc_h0/i_ibes_crsp_data$median_forecast_h0
  pe_ttm_median_h0[abs(i_ibes_crsp_data$median_forecast_h0)<=thresh1] <- i_ibes_crsp_data$prc_h0[abs(i_ibes_crsp_data$median_forecast_h0)<=thresh1]/thresh1*sign(i_ibes_crsp_data$median_forecast_h0[abs(i_ibes_crsp_data$median_forecast_h0)<=thresh1])
  
  pe_ttm_mean_h1 <- i_ibes_crsp_data$prc_h0/i_ibes_crsp_data$mean_forecast_h1
  pe_ttm_mean_h1[abs(i_ibes_crsp_data$mean_forecast_h1)<=thresh1] <- i_ibes_crsp_data$prc_h1[abs(i_ibes_crsp_data$mean_forecast_h1)<=thresh1]/thresh1*sign(i_ibes_crsp_data$mean_forecast_h1[abs(i_ibes_crsp_data$mean_forecast_h1)<=thresh1])
  
  pe_ttm_median_h1 <- i_ibes_crsp_data$prc_h0/i_ibes_crsp_data$median_forecast_h1
  pe_ttm_median_h1[abs(i_ibes_crsp_data$median_forecast_h1)<=thresh1] <- i_ibes_crsp_data$prc_h1[abs(i_ibes_crsp_data$median_forecast_h1)<=thresh1]/thresh1*sign(i_ibes_crsp_data$median_forecast_h1[abs(i_ibes_crsp_data$median_forecast_h1)<=thresh1])
  
  pe_ttm_actual_date <- i_ibes_crsp_data$quarter_date
  pe_h0_date <- i_ibes_crsp_data$crsp_date_h0
  pe_h1_date <- i_ibes_crsp_data$crsp_date_h1

  pe_ttm_actual_date <- as.Date(pe_ttm_actual_date,origin=lubridate::origin)
  pe_h0_date <- as.Date(pe_h0_date,origin=lubridate::origin)
  pe_h1_date <- as.Date(pe_h1_date,origin=lubridate::origin)

  # tmp_dataframe <- data.frame(pe_ttm_actual_date=pe_ttm_actual_date,pe_ttm_actual=pe_ttm_actual,pe_ttm_actual_announce=pe_ttm_actual_announce,eps_sum_actual=eps_sum_actual,
  #                             pe_h0_date=pe_h0_date,pe_ttm_mean_h0=pe_ttm_mean_h0,pe_ttm_median_h0=pe_ttm_median_h0,eps_sum_mean_h0=eps_sum_mean_h0,eps_sum_median_h0=eps_sum_median_h0,
  #                             pe_h1_date=pe_h1_date,pe_ttm_mean_h1=pe_ttm_mean_h1,pe_ttm_median_h1=pe_ttm_median_h1,eps_sum_mean_h1=eps_sum_mean_h1,eps_sum_median_h1=eps_sum_median_h1)
  tmp_dataframe <- data.frame(pe_ttm_actual_date=pe_ttm_actual_date,pe_ttm_actual=pe_ttm_actual,pe_ttm_actual_announce=pe_ttm_actual_announce,
                              pe_h0_date=pe_h0_date,pe_ttm_mean_h0=pe_ttm_mean_h0,pe_ttm_median_h0=pe_ttm_median_h0,
                              pe_h1_date=pe_h1_date,pe_ttm_mean_h1=pe_ttm_mean_h1,pe_ttm_median_h1=pe_ttm_median_h1)
  tmp_jointdataframe <- cbind(i_ibes_crsp_data,tmp_dataframe)
  pe_ratio_ibes_crsp <- rbind(pe_ratio_ibes_crsp,tmp_jointdataframe)
}
load("ticker_exclude.RData")
pe_ratio_ibes_crsp_exclude <- pe_ratio_ibes_crsp[pe_ratio_ibes_crsp$ticker%in%ticker_exclude,]
pe_ratio_ibes_crsp <- pe_ratio_ibes_crsp[!pe_ratio_ibes_crsp$ticker%in%ticker_exclude,]
save(pe_ratio_ibes_crsp,pe_ratio_ibes_crsp_exclude,file = "pe_ratio_ibes_crsp.RData")
length(unique(pe_ratio_ibes_crsp$ticker))
