load("pe_ratio_ibes_crsp.RData")
ff_classif <- read.csv("siccodes10.csv")
permno_ff_link_table <- read.csv("permno-ff10.csv")

ticker <- unique(pe_ratio_ibes_crsp$ticker)
pe_ratio_ibes_crsp_ff <- data.frame()

for (i in seq(length(ticker))){
  i_ticker <- as.character(ticker[i])
  i_pe_ratio_ibes_crsp <- pe_ratio_ibes_crsp[pe_ratio_ibes_crsp$ticker%in%i_ticker,]
  n <- dim(i_pe_ratio_ibes_crsp)[1]
  i_permno <- i_pe_ratio_ibes_crsp$crsp_permno
  i_permno <- unique(i_permno,fromLast = TRUE)
  i_permno <- i_permno[seq(length(i_permno),1,by=-1)]
  if(length(i_permno)>1){
    # take most recent permno for i_ticker and go back:
    k <- 1
    link_table_empty <- TRUE
    while (link_table_empty){
      i_permno_tmp <- i_permno[k]
      i_permno_ff_link <- permno_ff_link_table[permno_ff_link_table$PERMNO%in%i_permno_tmp,]
      link_table_empty <- dim(i_permno_ff_link)[1]==0
      k <- k + 1
    }
  } else {
    i_permno_ff_link <- permno_ff_link_table[permno_ff_link_table$PERMNO%in%i_permno,]
  }
  i_ff_num <- i_permno_ff_link$FF_10IND_NUM
  i_ff_name <- as.character(permno_ff_link_table[permno_ff_link_table$PERMNO%in%i_permno,]$FF_10IND_NAME)
  # take most recent ff classification for i_ticker: 
  i_ff_num <- i_ff_num[length(i_ff_num)]
  i_ff_name <- i_ff_name[length(i_ff_name)]
  i_sic <- i_permno_ff_link$SIC
  # take most recent sic code:
  i_sic <- i_sic[length(i_sic)]
  idx <- which(ff_classif$SIC1 <= i_sic & i_sic <=  ff_classif$SIC2)
  if (length(idx)!=0){
    check_sic <- ff_classif[idx, ]$FF10==i_ff_num
  } else {
    check_sic <- 10==i_ff_num
  }
  
  if (!check_sic)
    stop("ff classification does not match")
  ff_10 <- rep(i_ff_num,times=n)
  ff_10_name <- rep(i_ff_name,times=n)

  i_pe_ratio_ibes_crsp <- cbind(i_pe_ratio_ibes_crsp,ff_10,ff_10_name)
  pe_ratio_ibes_crsp_ff <- rbind(pe_ratio_ibes_crsp_ff,i_pe_ratio_ibes_crsp)
}
## sort based on ff classification (nicer to group fixed effects later on)
pe_ratio_ibes_crsp_ff_sorted <- rbind(pe_ratio_ibes_crsp_ff[pe_ratio_ibes_crsp_ff$ff_10==1,],
      pe_ratio_ibes_crsp_ff[pe_ratio_ibes_crsp_ff$ff_10==2,],
      pe_ratio_ibes_crsp_ff[pe_ratio_ibes_crsp_ff$ff_10==3,],
      pe_ratio_ibes_crsp_ff[pe_ratio_ibes_crsp_ff$ff_10==4,],
      pe_ratio_ibes_crsp_ff[pe_ratio_ibes_crsp_ff$ff_10==5,],
      pe_ratio_ibes_crsp_ff[pe_ratio_ibes_crsp_ff$ff_10==6,],
      pe_ratio_ibes_crsp_ff[pe_ratio_ibes_crsp_ff$ff_10==7,],
      pe_ratio_ibes_crsp_ff[pe_ratio_ibes_crsp_ff$ff_10==8,],
      pe_ratio_ibes_crsp_ff[pe_ratio_ibes_crsp_ff$ff_10==9,],
      pe_ratio_ibes_crsp_ff[pe_ratio_ibes_crsp_ff$ff_10==10,])
pe_ratio_ibes_crsp_ff <- pe_ratio_ibes_crsp_ff_sorted   

# compute number of firms per industry:
ticker <- unique(pe_ratio_ibes_crsp_ff$ticker)
num_per_ind <- numeric(10)
for (i in seq(10)){
  num_per_ind[i] <- sum(ticker%in%pe_ratio_ibes_crsp_ff[pe_ratio_ibes_crsp_ff$ff_10==i,]$ticker)
}
save(pe_ratio_ibes_crsp_ff,num_per_ind,file = "pe_ratio_ibes_crsp_ff.RData")
setwd('..')
setwd(paste0(getwd(),.Platform$file.sep,"new_data_all/"))
save(pe_ratio_ibes_crsp_ff,num_per_ind,file = "pe_ratio_ibes_crsp_ff.RData")


