rm(list=ls())
# ------- SET WORKING DIRECTORY ------- #
if (! "rstudioapi" %in% installed.packages() ) install.packages("rstudioapi")
wd <- dirname(rstudioapi::getSourceEditorContext()$path)
setwd(wd)

if (! "lubridate" %in% installed.packages() ) install.packages("lubridate") # version 1.7.4
if (! "midasml" %in% installed.packages() ) install.packages("midasml") # version 0.0.5
if (! "xlsx" %in% installed.packages() ) install.packages("xlsx") # version 0.6.3
library(lubridate) 
library(midasml) 
library(xlsx) 

# download csv files for full sample from WRDS and name:

# eps-wrds-new-ibes.csv - full ibes data file
# ibes-crsp-link.csv - ibes crsp link table
# prices-crsp-daily.csv - full crsp daily stock prices
# prices-crsp.csv - full crsp monthly stock prices
# siccodes10.csv
# permno-ff10.csv - 
# ticker_exclude.RData - tickers to exclude from final computation due to extremely erratic time series.

# run ibes data sorting file (in two chunks as it is large and takes up a lot of RAM)
# run_ibes_sort.R need files: eps-wrds-new-ibes.csv; prices-crsp.csv; ibes-crsp-link.csv.
# computes: ibes_sorted.RData data file with sorted IBES data. 
source("run_ibes_sort.R") 
# match crsp and ibes data & clean - stores data only without missing entries
# crsp_ibes_match.R needs files: prices-crsp-daily.csv; ibes_sorted.RData.
# computes: ibes_crsp_data.RData
source("crsp_ibes_match.R")
# compute pe ratios
# crsp_ibes_pe_ratio.R needs files: ibes_crsp_data.RData; ticker_exclude.RData
# computes: pe_ratio_ibes_crsp.RData
source("crsp_ibes_pe_ratio.R")
# add fama-french classfication
# crsp_ibes_pe_ratio_ff.R needs files: pe_ratio_ibes_crsp.RData; siccodes10.csv; permno-ff10.csv.
# computes: pe_ratio_ibes_crsp_ff.RData. This file should be pasted to 'compile-all-data' folder
source("crsp_ibes_pe_ratio_ff.R")
